/*******************************************************************
                    3D Area Copy AviUtl Plug-In
 *******************************************************************/
#include <windows.h>
#include <commctrl.h>
#include <zmouse.h>
#include "filter.h"

/*------------------------------------------------------------------
   dialog item IDs
 ------------------------------------------------------------------*/
#define ID_FRAME_EDIT      1003
#define ID_FRAME_UPDOWN    1004
#define ID_END_EDIT         1030 //ǉ
#define ID_END_UPDOWN       1031 //ǉ
#define ID_TOP_EDIT        1005
#define ID_TOP_UPDOWN      1006
#define ID_LEFT_EDIT       1007
#define ID_LEFT_UPDOWN     1008
#define ID_RIGHT_EDIT      1009
#define ID_RIGHT_UPDOWN    1010
#define ID_BOTTOM_EDIT     1011
#define ID_BOTTOM_UPDOWN   1012
#define ID_T_FRAME_EDIT     1032 //ǉ
#define ID_T_FRAME_UPDOWN   1033 //ǉ
#define ID_T_END_EDIT       1038 //ǉ_plus
#define ID_T_END_UPDOWN     1039 //ǉ_plus
#define ID_T_TOP_EDIT       1034 //ǉ
#define ID_T_TOP_UPDOWN     1035 //ǉ
#define ID_T_LEFT_EDIT      1036 //ǉ
#define ID_T_LEFT_UPDOWN    1037 //ǉ
#define ID_Y_CHECK         1013
#define ID_Y_LEVEL_EDIT    1014
#define ID_Y_LEVEL_UPDOWN  1015
#define ID_Y_RANGE_EDIT    1016
#define ID_Y_RANGE_UPDOWN  1017
#define ID_CB_CHECK        1018
#define ID_CB_LEVEL_EDIT   1019
#define ID_CB_LEVEL_UPDOWN 1020
#define ID_CB_RANGE_EDIT   1021
#define ID_CB_RANGE_UPDOWN 1022
#define ID_CR_CHECK        1023
#define ID_CR_LEVEL_EDIT   1024
#define ID_CR_LEVEL_UPDOWN 1025
#define ID_CR_RANGE_EDIT   1026
#define ID_CR_RANGE_UPDOWN 1027
#define ID_REVERSE_CHECK   1028

/*------------------------------------------------------------------
   origina data structure
 ------------------------------------------------------------------*/
typedef struct {
	int frame;
	int end; //ǉ
	int left;
	int top;
	int right;
	int bottom;
	int t_frame; //ǉ
	int t_end; //ǉ_plus
	int t_left; //ǉ
	int t_top; //ǉ
	int y_check;
	int y_level;
	int y_range;
	int cb_check;
	int cb_level;
	int cb_range;
	int cr_check;
	int cr_level;
	int cr_range;
	int reverse_check;
} AREA_COPY_SETUP_DATA;

typedef struct {
	HFONT normal_font;
	HFONT text_font;

	HWND  frame_label;
	HWND  frame_edit;
	HWND  frame_updown;

	HWND  end_label; //ǉ
	HWND  end_edit; //ǉ
	HWND  end_updown; //ǉ

	HWND  area_group;

	HWND  top_label;
	HWND  top_edit;
	HWND  top_updown;

	HWND  left_label;
	HWND  left_edit;
	HWND  left_updown;

	HWND  right_label;
	HWND  right_edit;
	HWND  right_updown;
	
	HWND  bottom_label;
	HWND  bottom_edit;
	HWND  bottom_updown;

	HWND  t_frame_label; //ǉ
	HWND  t_frame_edit; //ǉ
	HWND  t_frame_updown; //ǉ

	HWND  t_end_label; //ǉ
	HWND  t_end_edit; //ǉ_plus
	HWND  t_end_updown; //ǉ_plus

	HWND  t_area_group; //ǉ

	HWND  t_top_label; //ǉ
	HWND  t_top_edit; //ǉ
	HWND  t_top_updown; //ǉ

	HWND  t_left_label; //ǉ
	HWND  t_left_edit; //ǉ
	HWND  t_left_updown; //ǉ

	HWND  t_right_label; //ǉ

	HWND  t_bottom_label; //ǉ

	HWND  color_range_group;
	HWND  color_level_label;
	HWND  color_range_label;

	HWND  y_check;
	HWND  y_level_edit;
	HWND  y_level_updown;
	HWND  y_range_edit;
	HWND  y_range_updown;

	HWND  cb_check;
	HWND  cb_level_edit;
	HWND  cb_level_updown;
	HWND  cb_range_edit;
	HWND  cb_range_updown;
	
	HWND  cr_check;
	HWND  cr_level_edit;
	HWND  cr_level_updown;
	HWND  cr_range_edit;
	HWND  cr_range_updown;

	HWND  reverse_check;

} AREA_COPY_DIALOG_ITEM;

/*------------------------------------------------------------------
   global variables
 ------------------------------------------------------------------*/
AREA_COPY_SETUP_DATA setup_data;
AREA_COPY_SETUP_DATA setup_max;
AREA_COPY_SETUP_DATA setup_min;
AREA_COPY_DIALOG_ITEM dialog_item;

/*------------------------------------------------------------------
   function prototypes
 ------------------------------------------------------------------*/
static void initialize_dialog(HWND hwnd, HINSTANCE hinst);
static void setup_min_max(EXFUNC *func, void *editp);
static void clear_dialog_resource();
static void on_filter_update();
static void on_frame_edit_change();
static void on_end_edit_change(); //ǉ
static void on_top_edit_change();
static void on_left_edit_change();
static void on_right_edit_change();
static void on_bottom_edit_change();
static void on_t_frame_edit_change(); //ǉ
static void on_t_end_edit_change(); //ǉ_plus
static void on_t_top_edit_change(); //ǉ
static void on_t_left_edit_change(); //ǉ
static void on_y_level_edit_change();
static void on_y_range_edit_change();
static void on_cb_level_edit_change();
static void on_cb_range_edit_change();
static void on_cr_level_edit_change();
static void on_cr_range_edit_change();
static void on_y_check_click();
static void on_cb_check_click();
static void on_cr_check_click();
static void on_reverse_check_click();
static int get_int(HWND in);
static int in_color_range(int x, int y, PIXEL_YC *source, int step, AREA_COPY_SETUP_DATA *cfg);

/*------------------------------------------------------------------
   filter infomation
 ------------------------------------------------------------------*/
#define	TRACK_N	0
char  *track_name[] = {"",};
int    track_default[] = {0, };
int    track_s[] = {0, };
int    track_e[] = {0, };

#define CHECK_N 1
char  *check_name[] = {"͈͊mF",};
int    check_default[] = {0, };

FILTER_DLL filter = {
	FILTER_FLAG_INFORMATION|FILTER_FLAG_WINDOW_SIZE|FILTER_FLAG_EX_DATA,
	320,402,
	"R̈敡plus",
	TRACK_N,
	track_name,
	track_default,
	track_s,track_e,
	CHECK_N,
	check_name,
	check_default,
	func_proc,
	NULL,
	NULL,
	NULL,
	func_WndProc,
	NULL,NULL,
	&setup_data,
	sizeof(AREA_COPY_SETUP_DATA),
	"beta ver. by mer",
	NULL,
	NULL,
};

/*------------------------------------------------------------------
   export function
 ------------------------------------------------------------------*/
FILTER_DLL __declspec(dllexport) * __stdcall GetFilterTable( void )
{
	memset(&setup_data, 0, sizeof(setup_data));
	return &filter;
}

/*------------------------------------------------------------------
   filter function
 ------------------------------------------------------------------*/
BOOL func_proc( FILTER *fp,FILTER_PROC_INFO *fpip )
{
	int i,j;

	AREA_COPY_SETUP_DATA s;
	AREA_COPY_SETUP_DATA t; /* target */
	
	int frame_bias,i_bias,j_bias;
	int t_from,t_to;
	
	PIXEL_YC *swap;
	
	static PIXEL_YC *source;
	
	s = setup_data;

	if(s.right > fpip->w){
		s.right = fpip->w;
	}
	if(s.bottom > fpip->h){
		s.bottom = fpip->h;
	}

	t.frame  = s.t_frame;
	//t.end    = s.t_frame+(s.end-s.frame);
	t.end    = s.t_end;
	t.top    = s.t_top;
	t.bottom = s.t_top+(s.bottom-s.top);
	t.left   = s.t_left;
	t.right  = s.t_left+(s.right-s.left);

	if(t.right > fpip->w){
		t.right = fpip->w;
		s.right = s.left+(t.right-t.left);
	}
	if(t.bottom > fpip->h){
		t.bottom = fpip->h;
		s.bottom = s.top+(t.bottom-t.top);
	}

	/* targetɂp[^̒lsourceł̒lɕϊ */
	frame_bias = s.frame-t.frame;
	i_bias = s.top-t.top;
	j_bias = s.left-t.left;

	t_from = t.frame<t.end ? t.frame : t.end;
	t_to = t.frame<t.end ? t.end : t.frame;

	if(fpip->frame < t_from || t_to < fpip->frame){
		if(fpip->frame < s.frame || s.end < fpip->frame){
		/*                 *
		 * nothing to edit *
		 *                 */
			fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->w, fpip->h, 1, 0);
			source = fp->exfunc->get_ycp_filtering_cache(fp, fpip->editp, fpip->frame);
			for(i=0;i<fpip->h;i++){
				memcpy(fpip->ycp_temp+(i*fpip->max_w), fpip->ycp_edit+(i*fpip->max_w), sizeof(PIXEL_YC)*fpip->w);
			}
		}else{
		/*               *
		 * source frames *
		 *               */
			fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->w, fpip->h, 1, 0);
			source = fp->exfunc->get_ycp_filtering_cache(fp, fpip->editp, fpip->frame);
			for(i=0;i<s.top;i++){
				memcpy(fpip->ycp_temp+(i*fpip->max_w), fpip->ycp_edit+(i*fpip->max_w), sizeof(PIXEL_YC)*fpip->w);
			}
			for(;i<s.bottom;i++){
				for(j=0;j<s.left;j++){
					fpip->ycp_temp[i*fpip->max_w+j] = fpip->ycp_edit[i*fpip->max_w+j];
				}
				for(;j<s.right;j++){
					if(fp->check[0]){
						fpip->ycp_temp[i*fpip->max_w+j].y = 0;
						fpip->ycp_temp[i*fpip->max_w+j].cb = 0;
						fpip->ycp_temp[i*fpip->max_w+j].cr = 0;
					}else{
						fpip->ycp_temp[i*fpip->max_w+j] = fpip->ycp_edit[i*fpip->max_w+j];
					}
				}
				for(;j<fpip->w;j++){
					fpip->ycp_temp[i*fpip->max_w+j] = fpip->ycp_edit[i*fpip->max_w+j];
				}
			}	
			for(;i<fpip->h;i++){
				memcpy(fpip->ycp_temp+(i*fpip->max_w), fpip->ycp_edit+(i*fpip->max_w), sizeof(PIXEL_YC)*fpip->w);
			}		
		}
	}else{
	/*               *
	 * target frames *
	 *               */
	 	int n_s, n_t, source_frame;
	 	
	 	if(t.frame < t.end){
			n_s = s.end-s.frame+1;
			n_t = t.end-t.frame+1;
			source_frame = (fpip->frame-t.frame)*n_s/n_t+s.frame;
		}else{
			n_s = s.end-s.frame+1;
			n_t = t.frame-t.end+1;
			source_frame = (t.frame-fpip->frame)*n_s/n_t+s.frame;
		}	 
	 
		fp->exfunc->set_ycp_filtering_cache_size(fp, fpip->w, fpip->h, 1, 0);
		source = fp->exfunc->get_ycp_filtering_cache(fp, fpip->editp, source_frame);
		/* copy i th line, which is over the copying area, from 0 to top */
		for(i=0;i<t.top;i++){
			memcpy(fpip->ycp_temp+(i*fpip->max_w), fpip->ycp_edit+(i*fpip->max_w), sizeof(PIXEL_YC)*fpip->w);
		}
		/* copy i th line, which is on the copying area, from top to bottom */
		for(;i<t.bottom;i++){
			/* copy j th pixel, which is to left of the copying area, from 0 to left */
			for(j=0;j<t.left;j++){
				fpip->ycp_temp[i*fpip->max_w+j] = fpip->ycp_edit[i*fpip->max_w+j];
			}
			/* copy j th pixel, which is on the copying area, from left to right */
			for(;j<t.right;j++){
				if(in_color_range(j+j_bias, i+i_bias, source, fpip->w, &s)){
					/* F͈͓Ŕ͈͊mFcheckIȂAԂ */
					if(fp->check[0] || (source == NULL)){
						fpip->ycp_temp[i*fpip->max_w+j].y = 4096;
						fpip->ycp_temp[i*fpip->max_w+j].cb = 0;
						fpip->ycp_temp[i*fpip->max_w+j].cr = 0;
					/* F͈͓Ŕ͈͊mFcheckItȂAsource畡 */
					}else{
						fpip->ycp_temp[i*fpip->max_w+j] = source[(i+i_bias)*fpip->w+(j+j_bias)];
					}
				/* F͈͊OȂÂ܂ */
				}else{
					fpip->ycp_temp[i*fpip->max_w+j] = fpip->ycp_edit[i*fpip->max_w+j];
				}
			}
			/*copy j th pixel, which is to right of the copying area, from right to the end */
			for(;j<fpip->w;j++){
				fpip->ycp_temp[i*fpip->max_w+j] = fpip->ycp_edit[i*fpip->max_w+j];
			}
		}	
		/* copy i th line, which is under the copying area, from bottom to the end */
		for(;i<fpip->h;i++){
			memcpy(fpip->ycp_temp+(i*fpip->max_w), fpip->ycp_edit+(i*fpip->max_w), sizeof(PIXEL_YC)*fpip->w);
		}		
	}

	/* swap fpip->ycp_temp and fpip->ycp_edit */
	swap = fpip->ycp_temp;
	fpip->ycp_temp = fpip->ycp_edit;
	fpip->ycp_edit = swap;

	return TRUE;
}

/*------------------------------------------------------------------
   filter setup window procedure
 ------------------------------------------------------------------*/
BOOL func_WndProc( HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam, void *editp, FILTER *fp )
{
	UNREFERENCED_PARAMETER(editp);
	
	switch(message){
	case WM_COMMAND:
		switch(HIWORD(wparam)){
		case EN_CHANGE:
			switch(LOWORD(wparam)){
			case ID_FRAME_EDIT:
				on_frame_edit_change();
				break;
			case ID_END_EDIT:
				on_end_edit_change();
				break;
			case ID_TOP_EDIT:
				on_top_edit_change();
				break;
			case ID_LEFT_EDIT:
				on_left_edit_change();
				break;
			case ID_RIGHT_EDIT:
				on_right_edit_change();
				break;
			case ID_BOTTOM_EDIT:
				on_bottom_edit_change();
				break;
			case ID_T_FRAME_EDIT:
				on_t_frame_edit_change();
				break;
			case ID_T_END_EDIT:
				on_t_end_edit_change();
				break;
			case ID_T_TOP_EDIT:
				on_t_top_edit_change();
				break;
			case ID_T_LEFT_EDIT:
				on_t_left_edit_change();
				break;
			case ID_Y_LEVEL_EDIT:
				on_y_level_edit_change();
				break;
			case ID_Y_RANGE_EDIT:
				on_y_range_edit_change();
				break;
			case ID_CB_LEVEL_EDIT:
				on_cb_level_edit_change();
				break;
			case ID_CB_RANGE_EDIT:
				on_cb_range_edit_change();
				break;
			case ID_CR_LEVEL_EDIT:
				on_cr_level_edit_change();
				break;
			case ID_CR_RANGE_EDIT:
				on_cr_range_edit_change();
				break;
			default:
				return FALSE;
			}
			return fp->exfunc->is_filter_active(fp);
		case BN_CLICKED:
			switch(LOWORD(wparam)){
			case ID_Y_CHECK:
				on_y_check_click();
				break;
			case ID_CB_CHECK:
				on_cb_check_click();
				break;
			case ID_CR_CHECK:
				on_cr_check_click();
				break;
			case ID_REVERSE_CHECK:
				on_reverse_check_click();
				break;
			default:
				return FALSE;
			}
			SetFocus(NULL);
			SetFocus(hwnd);
			return fp->exfunc->is_filter_active(fp);
		}
		break;
	case WM_NOTIFY:
		switch( ((LPNMHDR)lparam)->code ){
		case UDN_DELTAPOS:
			SetFocus(NULL);
			SetFocus(hwnd);
			break;
		}
		break;
	case WM_KEYUP:
	case WM_KEYDOWN:
	case WM_MOUSEWHEEL:
		SendMessage(GetWindow(hwnd, GW_OWNER), message, wparam, lparam);
		break;
	case WM_FILTER_INIT:
		setup_min_max(fp->exfunc, editp);
		initialize_dialog(hwnd, fp->dll_hinst);
		break;
	case WM_FILTER_EXIT:
		clear_dialog_resource();
		break;
	case WM_FILTER_UPDATE:
		on_filter_update();
	}

	return FALSE;
}

/*-----------------------------------------------------------------*/
void initialize_dialog(HWND hwnd, HINSTANCE hinst)
{
	AREA_COPY_DIALOG_ITEM *d;
	AREA_COPY_SETUP_DATA *s;

	AREA_COPY_SETUP_DATA save;
	const AREA_COPY_SETUP_DATA *max;
	const AREA_COPY_SETUP_DATA *min;
	
	const int DIALOG_TOP = 24;

	const int CRG_CHECK_LEFT   = 36;
	const int CRG_LEVEL_LEFT   = 100;
	const int CRG_RANGE_LEFT   = 200;
	const int CRG_LABEL_TOP    = 252;
	const int CRG_Y_TOP        = CRG_LABEL_TOP+20;
	const int CRG_CB_TOP       = CRG_LABEL_TOP+46;
	const int CRG_CR_TOP       = CRG_LABEL_TOP+72;
	const int CRG_REVERSE_LEFT = 254;

	d = &dialog_item;
	s = &setup_data;
	save = *s;

	max = &setup_max;
	min = &setup_min;
	
	/* create font */
	
	d->normal_font = CreateFont(12, 0, 0, 0, FW_MEDIUM, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH | FF_MODERN, "lr oSVbN");
	d->text_font = CreateFont(14, 0, 0, 0, FW_MEDIUM, FALSE, FALSE, FALSE, SHIFTJIS_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, DEFAULT_PITCH | FF_MODERN, "lr oSVbN");

	/* create frame */
	
	d->frame_label = CreateWindow("STATIC", "Rs[", WS_CHILD|WS_VISIBLE, 17, DIALOG_TOP+16, 50, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->frame_label, WM_SETFONT, (WPARAM)d->normal_font, 0);

	d->frame_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, 73, DIALOG_TOP+13, 70, 18, hwnd, (HMENU)ID_FRAME_EDIT, hinst, NULL);
	SendMessage(d->frame_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->frame_edit, EM_LIMITTEXT, (WPARAM)6, 0);
	ImmAssociateContext(d->frame_edit, NULL); /* disable IME */
	
	d->frame_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, 150, DIALOG_TOP+13, 10, 18, hwnd, (HMENU)ID_FRAME_UPDOWN, hinst, NULL);
	SendMessage(d->frame_updown, UDM_SETRANGE32, (WPARAM)min->frame, (LPARAM)max->frame);

	/* create end */
	
	d->end_label = CreateWindow("STATIC", "`", WS_CHILD|WS_VISIBLE, 150, DIALOG_TOP+16, 20, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->end_label, WM_SETFONT, (WPARAM)d->normal_font, 0);

	d->end_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, 170, DIALOG_TOP+13, 70, 18, hwnd, (HMENU)ID_END_EDIT, hinst, NULL);
	SendMessage(d->end_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->end_edit, EM_LIMITTEXT, (WPARAM)6, 0);
	ImmAssociateContext(d->end_edit, NULL); /* disable IME */
	
	d->end_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, 240, DIALOG_TOP+13, 10, 18, hwnd, (HMENU)ID_END_UPDOWN, hinst, NULL);
	SendMessage(d->end_updown, UDM_SETRANGE32, (WPARAM)min->end, (LPARAM)max->end);

	/* create area group box */
	
	d->area_group = CreateWindow("BUTTON", "Rs[̈", WS_CHILD|WS_VISIBLE|BS_GROUPBOX, 8, DIALOG_TOP+38, 300, 78, hwnd, NULL, hinst, NULL);
	SendMessage(d->area_group, WM_SETFONT, (WPARAM)d->normal_font, 0);

	/* create top */
	
	d->top_label = CreateWindow("STATIC", "", WS_CHILD|WS_VISIBLE, 120, DIALOG_TOP+60, 18, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->top_label, WM_SETFONT, (WPARAM)d->normal_font, 0);

	d->top_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, 140, DIALOG_TOP+57, 50, 18, hwnd, (HMENU)ID_TOP_EDIT, hinst, NULL);
	SendMessage(d->top_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->top_edit, EM_LIMITTEXT, (WPARAM)3, 0);
	ImmAssociateContext(d->top_edit, NULL); /* disable IME */

	d->top_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, 190, DIALOG_TOP+57, 10, 18, hwnd, (HMENU)ID_TOP_UPDOWN, hinst, NULL);
	SendMessage(d->top_updown, UDM_SETRANGE32, (WPARAM)min->top, (LPARAM)max->top);

	/* create left */
	
	d->left_label = CreateWindow("STATIC", "", WS_CHILD|WS_VISIBLE, 20, DIALOG_TOP+75, 18, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->left_label, WM_SETFONT, (WPARAM)d->normal_font, 0);

	d->left_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, 40, DIALOG_TOP+72, 50, 18, hwnd, (HMENU)ID_LEFT_EDIT, hinst, NULL);
	SendMessage(d->left_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->left_edit, EM_LIMITTEXT, (WPARAM)3, 0);
	ImmAssociateContext(d->left_edit, NULL); /* disable IME */

	d->left_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, 90, DIALOG_TOP+72, 10, 18, hwnd, (HMENU)ID_TOP_UPDOWN, hinst, NULL);
	SendMessage(d->left_updown, UDM_SETRANGE32, (WPARAM)min->left, (LPARAM)max->left);
		
	/* create right */
	
	d->right_label = CreateWindow("STATIC", "E", WS_CHILD|WS_VISIBLE, 220, DIALOG_TOP+75, 18, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->right_label, WM_SETFONT, (WPARAM)d->normal_font, 0);

	d->right_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, 240, DIALOG_TOP+72, 50, 18, hwnd, (HMENU)ID_RIGHT_EDIT, hinst, NULL);
	SendMessage(d->right_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->right_edit, EM_LIMITTEXT, (WPARAM)3, 0);
	ImmAssociateContext(d->right_edit, NULL); /* disable IME */

	d->right_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, 290, DIALOG_TOP+72, 10, 18, hwnd, (HMENU)ID_TOP_UPDOWN, hinst, NULL);
	SendMessage(d->right_updown, UDM_SETRANGE32, (WPARAM)min->right, (LPARAM)max->right);
		
	/* create bottom */
	
	d->bottom_label = CreateWindow("STATIC", "", WS_CHILD|WS_VISIBLE, 120, DIALOG_TOP+90, 18, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->bottom_label, WM_SETFONT, (WPARAM)d->normal_font, 0);

	d->bottom_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, 140, DIALOG_TOP+87, 50, 18, hwnd, (HMENU)ID_BOTTOM_EDIT, hinst, NULL);
	SendMessage(d->bottom_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->bottom_edit, EM_LIMITTEXT, (WPARAM)3, 0);
	ImmAssociateContext(d->bottom_edit, NULL); /* disable IME */

	d->bottom_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, 190, DIALOG_TOP+87, 10, 18, hwnd, (HMENU)ID_TOP_UPDOWN, hinst, NULL);
	SendMessage(d->bottom_updown, UDM_SETRANGE32, (WPARAM)min->bottom, (LPARAM)max->bottom);

	/* create t_frame */
	
	d->t_frame_label = CreateWindow("STATIC", "Rs[", WS_CHILD|WS_VISIBLE, 17, DIALOG_TOP+132, 50, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->t_frame_label, WM_SETFONT, (WPARAM)d->normal_font, 0);

	d->t_frame_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, 73, DIALOG_TOP+129, 70, 18, hwnd, (HMENU)ID_T_FRAME_EDIT, hinst, NULL);
	SendMessage(d->t_frame_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->t_frame_edit, EM_LIMITTEXT, (WPARAM)6, 0);
	ImmAssociateContext(d->t_frame_edit, NULL); /* disable IME */
	
	d->t_frame_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, 150, DIALOG_TOP+129, 10, 18, hwnd, (HMENU)ID_T_FRAME_UPDOWN, hinst, NULL);
	SendMessage(d->t_frame_updown, UDM_SETRANGE32, (WPARAM)min->t_frame, (LPARAM)max->t_frame);

	/* create t_end */
	
	d->t_end_label = CreateWindow("STATIC", "`", WS_CHILD|WS_VISIBLE, 150, DIALOG_TOP+132, 20, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->t_end_label, WM_SETFONT, (WPARAM)d->normal_font, 0);

	d->t_end_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, 170, DIALOG_TOP+129, 70, 18, hwnd, (HMENU)ID_T_END_EDIT, hinst, NULL);
	SendMessage(d->t_end_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->t_end_edit, EM_LIMITTEXT, (WPARAM)6, 0);
	ImmAssociateContext(d->t_end_edit, NULL); /* disable IME */
	
	d->t_end_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, 240, DIALOG_TOP+129, 10, 18, hwnd, (HMENU)ID_T_END_UPDOWN, hinst, NULL);
	SendMessage(d->t_end_updown, UDM_SETRANGE32, (WPARAM)min->t_end, (LPARAM)max->t_end);

	/* create t_area group box */
	
	d->t_area_group = CreateWindow("BUTTON", "Rs[̈", WS_CHILD|WS_VISIBLE|BS_GROUPBOX, 8, DIALOG_TOP+154, 300, 78, hwnd, NULL, hinst, NULL);
	SendMessage(d->t_area_group, WM_SETFONT, (WPARAM)d->normal_font, 0);

	/* create t_top */
	
	d->t_top_label = CreateWindow("STATIC", "", WS_CHILD|WS_VISIBLE, 120, DIALOG_TOP+176, 18, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->t_top_label, WM_SETFONT, (WPARAM)d->normal_font, 0);

	d->t_top_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, 140, DIALOG_TOP+173, 50, 18, hwnd, (HMENU)ID_T_TOP_EDIT, hinst, NULL);
	SendMessage(d->t_top_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->t_top_edit, EM_LIMITTEXT, (WPARAM)3, 0);
	ImmAssociateContext(d->t_top_edit, NULL); /* disable IME */

	d->t_top_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, 190, DIALOG_TOP+173, 10, 18, hwnd, (HMENU)ID_T_TOP_UPDOWN, hinst, NULL);
	SendMessage(d->t_top_updown, UDM_SETRANGE32, (WPARAM)min->t_top, (LPARAM)max->t_top);

	/* create t_left */
	
	d->t_left_label = CreateWindow("STATIC", "", WS_CHILD|WS_VISIBLE, 20, DIALOG_TOP+191, 18, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->t_left_label, WM_SETFONT, (WPARAM)d->normal_font, 0);

	d->t_left_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, 40, DIALOG_TOP+188, 50, 18, hwnd, (HMENU)ID_T_LEFT_EDIT, hinst, NULL);
	SendMessage(d->t_left_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->t_left_edit, EM_LIMITTEXT, (WPARAM)3, 0);
	ImmAssociateContext(d->t_left_edit, NULL); /* disable IME */

	d->t_left_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, 90, DIALOG_TOP+188, 10, 18, hwnd, (HMENU)ID_T_LEFT_UPDOWN, hinst, NULL);
	SendMessage(d->t_left_updown, UDM_SETRANGE32, (WPARAM)min->t_left, (LPARAM)max->t_left);
		
	/* create t_right */
	
	d->t_right_label = CreateWindow("STATIC", "E", WS_CHILD|WS_VISIBLE, 220, DIALOG_TOP+191, 18, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->t_right_label, WM_SETFONT, (WPARAM)d->normal_font, 0);
		
	/* create t_bottom */
	
	d->t_bottom_label = CreateWindow("STATIC", "", WS_CHILD|WS_VISIBLE, 120, DIALOG_TOP+206, 18, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->t_bottom_label, WM_SETFONT, (WPARAM)d->normal_font, 0);

	/* create color range group box */
	d->color_range_group = CreateWindow("BUTTON", "F͈", WS_CHILD|WS_VISIBLE|BS_GROUPBOX, 8, DIALOG_TOP+238, 300, 112, hwnd, NULL, hinst, NULL);
	SendMessage(d->color_range_group, WM_SETFONT, (WPARAM)d->normal_font, 0);

	/* create labels */
	d->color_level_label = CreateWindow("STATIC", "l", WS_CHILD|WS_VISIBLE, CRG_LEVEL_LEFT, DIALOG_TOP+CRG_LABEL_TOP, 40, 18, hwnd, NULL, hinst, NULL);
	d->color_range_label = CreateWindow("STATIC", "͈", WS_CHILD|WS_VISIBLE, CRG_RANGE_LEFT, DIALOG_TOP+CRG_LABEL_TOP, 40, 18, hwnd, NULL, hinst, NULL);
	SendMessage(d->color_level_label, WM_SETFONT, (WPARAM)d->normal_font, 0);
	SendMessage(d->color_range_label, WM_SETFONT, (WPARAM)d->normal_font, 0);

	/* create y */
	d->y_check = CreateWindow("BUTTON", "Y", WS_CHILD|WS_VISIBLE|BS_CHECKBOX, CRG_CHECK_LEFT, DIALOG_TOP+CRG_Y_TOP+1, 40, 18, hwnd, (HMENU)ID_Y_CHECK, hinst, NULL);
	SendMessage(d->y_check, WM_SETFONT, (WPARAM)d->normal_font, 0);
	
	d->y_level_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, CRG_LEVEL_LEFT, DIALOG_TOP+CRG_Y_TOP, 80, 18, hwnd, (HMENU)ID_Y_LEVEL_EDIT, hinst, NULL);
	SendMessage(d->y_level_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->y_level_edit, EM_LIMITTEXT, (WPARAM)3, 0);
	ImmAssociateContext(d->y_level_edit, NULL); /* disable IME */
	
	d->y_level_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, CRG_LEVEL_LEFT+80, DIALOG_TOP+CRG_Y_TOP, 10, 18, hwnd, (HMENU)ID_Y_LEVEL_UPDOWN, hinst, NULL);
	SendMessage(d->y_level_updown, UDM_SETRANGE32, (WPARAM)min->y_level, (LPARAM)max->y_level);

	d->y_range_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, CRG_RANGE_LEFT, DIALOG_TOP+CRG_Y_TOP, 80, 18, hwnd, (HMENU)ID_Y_RANGE_EDIT, hinst, NULL);
	SendMessage(d->y_range_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->y_range_edit, EM_LIMITTEXT, (WPARAM)3, 0);
	ImmAssociateContext(d->y_range_edit, NULL); /* disable IME */
	
	d->y_range_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, CRG_RANGE_LEFT+80, DIALOG_TOP+CRG_Y_TOP, 10, 18, hwnd, (HMENU)ID_Y_RANGE_UPDOWN, hinst, NULL);
	SendMessage(d->y_range_updown, UDM_SETRANGE32, (WPARAM)min->y_range, (LPARAM)max->y_range);

	/* create cb */
	d->cb_check = CreateWindow("BUTTON", "Cb", WS_CHILD|WS_VISIBLE|BS_CHECKBOX, CRG_CHECK_LEFT, DIALOG_TOP+CRG_CB_TOP+1, 40, 18, hwnd, (HMENU)ID_CB_CHECK, hinst, NULL);
	SendMessage(d->cb_check, WM_SETFONT, (WPARAM)d->normal_font, 0);
	
	d->cb_level_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, CRG_LEVEL_LEFT, DIALOG_TOP+CRG_CB_TOP, 80, 18, hwnd, (HMENU)ID_CB_LEVEL_EDIT, hinst, NULL);
	SendMessage(d->cb_level_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->cb_level_edit, EM_LIMITTEXT, (WPARAM)3, 0);
	ImmAssociateContext(d->cb_level_edit, NULL); /* disable IME */
	
	d->cb_level_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, CRG_LEVEL_LEFT+80, DIALOG_TOP+CRG_CB_TOP, 10, 18, hwnd, (HMENU)ID_CB_LEVEL_UPDOWN, hinst, NULL);
	SendMessage(d->cb_level_updown, UDM_SETRANGE32, (WPARAM)min->cb_level, (LPARAM)max->cb_level);

	d->cb_range_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, CRG_RANGE_LEFT, DIALOG_TOP+CRG_CB_TOP, 80, 18, hwnd, (HMENU)ID_CB_RANGE_EDIT, hinst, NULL);
	SendMessage(d->cb_range_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->cb_range_edit, EM_LIMITTEXT, (WPARAM)3, 0);
	ImmAssociateContext(d->cb_range_edit, NULL); /* disable IME */
	
	d->cb_range_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, CRG_RANGE_LEFT+80, DIALOG_TOP+CRG_CB_TOP, 10, 18, hwnd, (HMENU)ID_CB_RANGE_UPDOWN, hinst, NULL);
	SendMessage(d->cb_range_updown, UDM_SETRANGE32, (WPARAM)min->cb_range, (LPARAM)max->cb_range);

	/* create cb */
	d->cr_check = CreateWindow("BUTTON", "Cr", WS_CHILD|WS_VISIBLE|BS_CHECKBOX, CRG_CHECK_LEFT, DIALOG_TOP+CRG_CR_TOP+1, 40, 18, hwnd, (HMENU)ID_CR_CHECK, hinst, NULL);
	SendMessage(d->cr_check, WM_SETFONT, (WPARAM)d->normal_font, 0);
	
	d->cr_level_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, CRG_LEVEL_LEFT, DIALOG_TOP+CRG_CR_TOP, 80, 18, hwnd, (HMENU)ID_CR_LEVEL_EDIT, hinst, NULL);
	SendMessage(d->cr_level_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->cr_level_edit, EM_LIMITTEXT, (WPARAM)3, 0);
	ImmAssociateContext(d->cr_level_edit, NULL); /* disable IME */
	
	d->cr_level_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, CRG_LEVEL_LEFT+80, DIALOG_TOP+CRG_CR_TOP, 10, 18, hwnd, (HMENU)ID_CR_LEVEL_UPDOWN, hinst, NULL);
	SendMessage(d->cr_level_updown, UDM_SETRANGE32, (WPARAM)min->cr_level, (LPARAM)max->cr_level);

	d->cr_range_edit = CreateWindowEx(WS_EX_CLIENTEDGE, "EDIT", NULL, WS_CHILD|WS_VISIBLE|ES_RIGHT|ES_NUMBER, CRG_RANGE_LEFT, DIALOG_TOP+CRG_CR_TOP, 80, 18, hwnd, (HMENU)ID_CR_RANGE_EDIT, hinst, NULL);
	SendMessage(d->cr_range_edit, WM_SETFONT, (WPARAM)d->text_font, 0);
	SendMessage(d->cr_range_edit, EM_LIMITTEXT, (WPARAM)3, 0);
	ImmAssociateContext(d->cr_range_edit, NULL); /* disable IME */
	
	d->cr_range_updown = CreateWindowEx(0, UPDOWN_CLASS, NULL, WS_CHILD|WS_VISIBLE|UDS_ALIGNRIGHT|UDS_ARROWKEYS|UDS_AUTOBUDDY|UDS_HOTTRACK|UDS_NOTHOUSANDS|UDS_SETBUDDYINT, CRG_RANGE_LEFT+80, DIALOG_TOP+CRG_CR_TOP, 10, 18, hwnd, (HMENU)ID_CR_RANGE_UPDOWN, hinst, NULL);
	SendMessage(d->cr_range_updown, UDM_SETRANGE32, (WPARAM)min->cr_range, (LPARAM)max->cr_range);

	/* create reverse check box */
	d->reverse_check = CreateWindow("BUTTON", "]", WS_CHILD|WS_VISIBLE|BS_CHECKBOX, CRG_REVERSE_LEFT, DIALOG_TOP+CRG_LABEL_TOP-2, 50, 18, hwnd, (HMENU)ID_REVERSE_CHECK, hinst, NULL);
	SendMessage(d->reverse_check, WM_SETFONT, (WPARAM)d->normal_font, 0);

	/* restore setup parameter */
	SendMessage(d->frame_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.frame);
	SendMessage(d->end_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.end);
	SendMessage(d->top_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.top);
	SendMessage(d->left_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.left);
	SendMessage(d->right_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.right);
	SendMessage(d->bottom_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.bottom);
	SendMessage(d->t_frame_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.t_frame);
	SendMessage(d->t_end_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.t_end);
	SendMessage(d->t_top_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.t_top);
	SendMessage(d->t_left_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.t_left);
	SendMessage(d->y_level_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.y_level);
	SendMessage(d->y_range_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.y_range);
	SendMessage(d->cb_level_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.cb_level);
	SendMessage(d->cb_range_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.cb_range);
	SendMessage(d->cr_level_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.cr_level);
	SendMessage(d->cr_range_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.cr_range);
	
	if(save.y_check){
		SendMessage(d->y_check, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	}else{
		SendMessage(d->y_check, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
	}
		
	if(save.cb_check){
		SendMessage(d->cb_check, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	}else{
		SendMessage(d->cb_check, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
	}
		
	if(save.cr_check){
		SendMessage(d->cr_check, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	}else{
		SendMessage(d->cr_check, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
	}
		
	if(save.reverse_check){
		SendMessage(d->reverse_check, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	}else{
		SendMessage(d->reverse_check, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
	}		
}

/*-----------------------------------------------------------------*/
void setup_min_max(EXFUNC *func,void *editp)
{
	SYS_INFO si;

	func->get_sys_info(editp, &si);

	memset(&setup_min, 0, sizeof(setup_min));
	setup_min.bottom = 1;
	setup_min.right = 1;
	
	setup_max.frame = si.max_frame;
	setup_max.end = si.max_frame;
	setup_max.left = si.max_w - 1;
	setup_max.top = si.max_h - 1;
	setup_max.right = si.max_w;
	setup_max.bottom = si.max_h;
	setup_max.t_frame = si.max_frame;
	setup_max.t_end = si.max_frame;
	setup_max.t_left = si.max_w - 1;
	setup_max.t_top = si.max_h - 1;
	setup_max.y_check = 1;
	setup_max.y_level = 255;
	setup_max.y_range = 128;
	setup_max.cb_check = 1;
	setup_max.cb_level = 255;
	setup_max.cb_range = 128;
	setup_max.cr_check = 1;
	setup_max.cr_level = 255;
	setup_max.cr_range = 128;
	setup_max.reverse_check = 1;
}

/*-----------------------------------------------------------------*/
void on_filter_update()
{
	AREA_COPY_DIALOG_ITEM *d;
	AREA_COPY_SETUP_DATA *s;

	AREA_COPY_SETUP_DATA save;
	
	d = &dialog_item;
	s = &setup_data;
	save = *s;
	
	SendMessage(d->frame_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.frame);
	SendMessage(d->end_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.end);
	SendMessage(d->top_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.top);
	SendMessage(d->left_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.left);
	SendMessage(d->right_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.right);
	SendMessage(d->bottom_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.bottom);
	SendMessage(d->t_frame_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.t_frame);
	SendMessage(d->t_end_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.t_end);
	SendMessage(d->t_top_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.t_top);
	SendMessage(d->t_left_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.t_left);
	SendMessage(d->y_level_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.y_level);
	SendMessage(d->y_range_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.y_range);
	SendMessage(d->cb_level_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.cb_level);
	SendMessage(d->cb_range_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.cb_range);
	SendMessage(d->cr_level_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.cr_level);
	SendMessage(d->cr_range_updown, UDM_SETPOS32, (WPARAM)0, (LPARAM)save.cr_range);

	if(save.y_check){
		SendMessage(d->y_check, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	}else{
		SendMessage(d->y_check, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
	}
		
	if(save.cb_check){
		SendMessage(d->cb_check, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	}else{
		SendMessage(d->cb_check, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
	}
		
	if(save.cr_check){
		SendMessage(d->cr_check, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	}else{
		SendMessage(d->cr_check, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
	}
		
	if(save.reverse_check){
		SendMessage(d->reverse_check, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	}else{
		SendMessage(d->reverse_check, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
	}		
}

/*-----------------------------------------------------------------*/
void clear_dialog_resource()
{
	AREA_COPY_DIALOG_ITEM *d;

	d = &dialog_item;

	DeleteObject(d->normal_font);
	DeleteObject(d->text_font);
}

/*-----------------------------------------------------------------*/
void on_frame_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->frame = get_int(d->frame_edit);
	
	if(s->frame > max->frame){
		SendMessage(d->frame_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->frame);
	}else if(s->frame < min->frame){
		SendMessage(d->frame_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->frame);
	}

	if(s->end < s->frame){
		SendMessage(d->end_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)s->frame);
	}
}

/*-----------------------------------------------------------------*/
void on_end_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->end = get_int(d->end_edit);
	
	if(s->end > max->end){
		SendMessage(d->end_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->end);
	}else if(s->end < min->end){
		SendMessage(d->end_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->end);
	}

	if(s->frame > s->end){
		SendMessage(d->frame_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)s->end);
	}
}

/*-----------------------------------------------------------------*/
void on_top_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->top = get_int(d->top_edit);

	if(s->top > max->top){
		SendMessage(d->top_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->top);
	}else if(s->top < min->top){
		SendMessage(d->top_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->top);
	}
	
	if(s->bottom < s->top){
		SendMessage(d->bottom_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)s->top+1);
	}
}

/*-----------------------------------------------------------------*/
void on_left_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->left = get_int(d->left_edit);

	if(s->left > max->left){
		SendMessage(d->left_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->left);
	}else if(s->left < min->left){
		SendMessage(d->left_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->left);
	}
	
	if(s->right < s->left){
		SendMessage(d->right_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)s->left+1);
	}
}

/*-----------------------------------------------------------------*/
void on_right_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->right = get_int(d->right_edit);

	if(s->right > max->right){
		SendMessage(d->right_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->right);
	}else if(s->right < min->right){
		SendMessage(d->right_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->right);
	}
	
	if(s->left > s->right){
		SendMessage(d->left_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)s->right-1);
	}
}

/*-----------------------------------------------------------------*/
void on_bottom_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->bottom = get_int(d->bottom_edit);

	if(s->bottom > max->bottom){
		SendMessage(d->bottom_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->bottom);
	}else if(s->bottom < min->bottom){
		SendMessage(d->bottom_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->bottom);
	}
	
	if(s->top > s->bottom){
		SendMessage(d->top_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)s->bottom-1);
	}
}

/*-----------------------------------------------------------------*/
void on_t_frame_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->t_frame = get_int(d->t_frame_edit);
	
	if(s->t_frame > max->t_frame){
		SendMessage(d->t_frame_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->t_frame);
	}else if(s->t_frame < min->t_frame){
		SendMessage(d->t_frame_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->t_frame);
	}
}

/*-----------------------------------------------------------------*/
void on_t_end_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->t_end = get_int(d->t_end_edit);
	
	if(s->t_end > max->t_end){
		SendMessage(d->t_end_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->t_end);
	}else if(s->t_end < min->t_end){
		SendMessage(d->t_end_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->t_end);
	}
}

/*-----------------------------------------------------------------*/
void on_t_top_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->t_top = get_int(d->t_top_edit);

	if(s->t_top > max->t_top){
		SendMessage(d->t_top_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->t_top);
	}else if(s->t_top < min->t_top){
		SendMessage(d->t_top_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->t_top);
	}
}

/*-----------------------------------------------------------------*/
void on_t_left_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->t_left = get_int(d->t_left_edit);

	if(s->t_left > max->t_left){
		SendMessage(d->t_left_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->t_left);
	}else if(s->t_left < min->t_left){
		SendMessage(d->t_left_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->t_left);
	}
}

/*-----------------------------------------------------------------*/
void on_y_level_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->y_level = get_int(d->y_level_edit);
	
	if(s->y_level > max->y_level){
		SendMessage(d->y_level_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->y_level);
	}else if(s->y_level < min->y_level){
		SendMessage(d->y_level_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->y_level);
	}
}

/*-----------------------------------------------------------------*/
void on_y_range_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->y_range = get_int(d->y_range_edit);
	
	if(s->y_range > max->y_range){
		SendMessage(d->y_range_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->y_range);
	}else if(s->y_range < min->y_range){
		SendMessage(d->y_range_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->y_range);
	}
}

/*-----------------------------------------------------------------*/
void on_cb_level_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->cb_level = get_int(d->cb_level_edit);
	
	if(s->cb_level > max->cb_level){
		SendMessage(d->cb_level_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->cb_level);
	}else if(s->cb_level < min->cb_level){
		SendMessage(d->cb_level_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->cb_level);
	}
}

/*-----------------------------------------------------------------*/
void on_cb_range_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->cb_range = get_int(d->cb_range_edit);
	
	if(s->cb_range > max->cb_range){
		SendMessage(d->cb_range_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->cb_range);
	}else if(s->cb_range < min->cb_range){
		SendMessage(d->cb_range_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->cb_range);
	}
}

/*-----------------------------------------------------------------*/
void on_cr_level_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->cr_level = get_int(d->cr_level_edit);
	
	if(s->cr_level > max->cr_level){
		SendMessage(d->cr_level_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->cr_level);
	}else if(s->cr_level < min->cr_level){
		SendMessage(d->cr_level_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->cr_level);
	}
}

/*-----------------------------------------------------------------*/
void on_cr_range_edit_change()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;
	
	const AREA_COPY_SETUP_DATA *max = &setup_max;
	const AREA_COPY_SETUP_DATA *min = &setup_min; 
	
	s->cr_range = get_int(d->cr_range_edit);
	
	if(s->cr_range > max->cr_range){
		SendMessage(d->cr_range_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)max->cr_range);
	}else if(s->cr_range < min->cr_range){
		SendMessage(d->cr_range_updown, UDM_SETPOS32, (LPARAM)0, (WPARAM)min->cr_range);
	}
}

/*-----------------------------------------------------------------*/
void on_y_check_click()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;

	s->y_check = !s->y_check;
	
	if(s->y_check){
		SendMessage(d->y_check, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	}else{
		SendMessage(d->y_check, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
	}
		
}

/*-----------------------------------------------------------------*/
void on_cb_check_click()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;

	s->cb_check = !s->cb_check;
	
	if(s->cb_check){
		SendMessage(d->cb_check, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	}else{
		SendMessage(d->cb_check, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
	}
}

/*-----------------------------------------------------------------*/
void on_cr_check_click()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;

	s->cr_check = !s->cr_check;
	
	if(s->cr_check){
		SendMessage(d->cr_check, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	}else{
		SendMessage(d->cr_check, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
	}		
}

/*-----------------------------------------------------------------*/
static void on_reverse_check_click()
{
	AREA_COPY_SETUP_DATA *s = &setup_data;
	AREA_COPY_DIALOG_ITEM *d = &dialog_item;

	s->reverse_check = !s->reverse_check;
	
	if(s->reverse_check){
		SendMessage(d->reverse_check, BM_SETCHECK, (WPARAM)BST_CHECKED, 0);
	}else{
		SendMessage(d->reverse_check, BM_SETCHECK, (WPARAM)BST_UNCHECKED, 0);
	}		
}

/*-----------------------------------------------------------------*/
static int get_int(HWND in)
{
	int ret;
	int n;
	char *buffer;

	n = SendMessage(in, WM_GETTEXTLENGTH, 0, 0) + 1;

	buffer = (char *)malloc(n);

	n = SendMessage(in, WM_GETTEXT, (WPARAM)n, (LPARAM)buffer);
	if(n > 0){
		ret = atoi(buffer);
	}else{
		ret = 0;
	}

	free(buffer);

	return ret;
}

/*-----------------------------------------------------------------*/
static int in_color_range(int x, int y, PIXEL_YC *source, int step, AREA_COPY_SETUP_DATA *cfg)
{
	int r;
	int max;
	int min;
	AREA_COPY_SETUP_DATA *s;

	s = cfg;

	r = 1;

	if(s->y_check){
		max = (s->y_level + s->y_range) * 16;
		min = (s->y_level - s->y_range) * 16;
		if(source[x+y*step].y > max){
			r = 0;
		}
		if(source[x+y*step].y < min){
			r = 0;
		}
	}

	if(s->cb_check){
		max = (s->cb_level + s->cb_range - 128) * 16;
		min = (s->cb_level - s->cb_range - 128) * 16;
		if(source[x+y*step].cb > max){
			r = 0;
		}
		if(source[x+y*step].cb < min){
			r = 0;
		}
	}

	if(s->cr_check){
		max = (s->cr_level + s->cr_range - 128) * 16;
		min = (s->cr_level - s->cr_range - 128) * 16;
		if(source[x+y*step].cr > max){
			r = 0;
		}
		if(source[x+y*step].cr < min){
			r = 0;
		}
	}

	if(s->reverse_check){
		r = !r;
	}
	
	return r;
}
